#!/usr/local/bin/bash

# YAUCG - Yes, another userfriendly comic grepper
# Read README first before writing me emails with your problem(s). Comments
# and bug reports are everytime welcome of course. 
# Thanks ;)
# tr0nix - tr0nix@rescueteam.com

#---------------------------VARIABLES FOR YOUR ENVIRONMENT --------------------------------#
http_proxy=""
proxy_user=""
proxy_passwd=""
picture_prog="" # Netscape is a good choice, also use options if needen
archive_dir="/tmp"
previous_check="2" # At least 1. No maximum ;) you could grep the cartoons of a whole year
mysql_support=false # Read README_WEB for information about this. Set to "true" to enable
#------------------------------------------------------------------------------------------#

error() # For giving out errors to stderr
{
 echo -e "\033[0;31mThere was a problem: $ERROR\033[0m" > /dev/stderr
 rm $INDEXFILE 2> /dev/null
 rm index.html 2> /dev/null
 exit 1
}

finish() # End of whole script..
{
 echo -e "\033[1;33mDone\033[0m"
 if [ "$picture_prog" != "" ]; then $picture_prog $archive_dir/$FILE; fi
 rm $INDEXFILE 2> /dev/null
 rm index.html 2> /dev/null
 if [ "$mysql_support" == "true" ]; then databaseentry; fi
 exit 0
}

previous_parse() # Parsing for URL's for previous comics-pages
{
 echo -e "\033[1;33mParsing for previous cartoons...\033[0m"
 GET=`echo -n "ars.userfriendly.org" ; grep "Previous Cartoon" $INDEXFILE | cut -d \" -f 4 -`
 rm $INDEXFILE
 INDEXFILE="?id\\=`echo $GET | cut -d \= -f 2 -`"

 JUMPPOINT="parse_normal"
 COUNT=`expr $COUNT + 1`
 if [ "$COUNT" == "$previous_check" ]; then JUMPPOINT="finish"; fi
 get
}

parse_normal() # Parsing section. Funny thing ;), but worked every day for weeks
{
 ERROR="Problems with parsing (strange...)"
 GET=`grep "Strip for" $INDEXFILE | cut -d \" -f 6 || error` 
 FILE=`echo $GET | cut -d \/ -f 7 -`

 if [ "$previous_check" != "" ]; then JUMPPOINT=previous_parse; else
 JUMPPOINT=finish; fi

 if [ -a "$archive_dir/$FILE" ]; then echo -e "\033[0;31m=>$FILE is already downloaded...\033[0m"; $JUMPPOINT; fi
 echo -e "\033[1;33mOky doky, index parsed. Now downloading $FILE\033[0m"
 FILELIST="$FILELIST $FILE"

 get
}

get() # Get the stuff
{
 ERROR="Downloading: Check your Internet connection and Proxy settings in the script (http_proxy). _Maybe_ parsing problem."
 wget $PROXY $GET 2> /dev/null || error
 ERROR="Archieving Picture. Check permission of $archive_dir"
 if [ -a "$FILE" ]; then (mv $FILE $archive_dir || error); fi

 $JUMPPOINT
}

main() # Main section, just for the basic beginning things
{
 clear
 echo -e "\033[1;33mYAUCG - Yes, another userfriendly comic grepper. Version: 0.1\033[0m"
 echo -e "\033[1;33mPlease mail me for coments.\033[0m"
 echo -e "\033[1;33mJoel Wiesmann, 2001 - <tr0nix at rescueteam dot com>\033[0m"
 echo -e "\033[1;33mPlease wait...\033[0m"

 # Some checks
 if [ "$http_proxy" != "" ]; then PROXY=" -Y on "; fi
 if [ "$proxy_user" != "" ]; then PROXY="$PROXY --proxy-user=$proxy_user --proxy-passwd=$proxy_passwd "; fi
 ERROR="You have root privileges! Log out and use another user."
 if [ `id -un` == "root" ]; then error; fi
 ERROR="Uh oh.. you should get wget first! Check out www.freshmeat.net"
 wget --help 2&> /dev/null || error
 
 COUNT=0
 INDEXFILE=index.html
 GET=ars.userfriendly.org/cartoons/index.html
 JUMPPOINT=parse_normal
 export http_proxy
 get
}

databaseentry() # MySQL Database Part
{
 cd $archive_dir
 COUNT=0

 # Don't we all like our names on stdout? 
 echo ""
 echo -e "\033[1;33mMySQL Database enhancement\033[0m"
 echo -e "\033[1;33mChristoph Lutz, 2001 - <christoph at intergga dot ch>\033[0m"
 echo -e "\033[1;33mPictures to add to the database:$FILELIST\033[0m"
 ERROR="Database Error! Do you have a local mysql database? Permissions of the executing user are correct? Is mysql accessible via \$PATH?"
 mysql --help 2&> /dev/null || error

 
 CMP1=`echo "SELECT * FROM uf.archive;" | mysql | cut -f 2 | cut -c 4-`

 # Herbschtmss loop
 for I in $FILELIST #<------------ Funktioniert das? -> line 59
 do
  if [ "$CMP1" != "" ]; then
  CMP2=`grep $I in $CMP1 2> /dev/null`;
  fi
   if [ "$CMP2" == "" ]; then
   echo -e "\033[0,31mNOT adding $I (ENTRY EXISTS) ...\033[0m";
   count=`expr $COUNT + 1`;
   else 
   echo "Adding $I to DB ...";
   echo "INSERT INTO uf.archive (URL) VALUES('$I');" | mysql;
   count=`expr $COUNT + 1`;
  fi
 done
 echo "Counted: [$count]"
 
 echo -e "\033[0;32mDONE!\033[m" 
}

main